#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <qdos.h>
#include <qptr.h>
#include "cview.h"

Prototype int SpawnCmd (char *, char *);

/*------------------------------------------------------.
| * SJOB structure defines parameters for spawned job.  |
`------------------------------------------------------*/

typedef struct
{
    char *FileName;
    char *ComStr;
    char *InFile;
    int inflag;
    char *OuFile;
    int ouid;
    int JobId;
    int serr;
    unsigned char Prio;
    unsigned char Wait;
} SJOB, *PSJOB;

static char * FullName(char *name, char *myname)
{
    char *p;
    int fnd;
    
    if(isdirdev (name) == 0)
    {
        if(getcpd(myname, 32))
        {
            p = strcat(myname, name);
        }
        if(access(p, 1) != 0)
        {
            if(getcwd(myname, 32))
            {
                p = strcat(myname, name);
            }
            else
            {
                p = name;
            }
        }
    }
    else
    {
        p = name;
    }
    return p;
}

int SpawnCmd (char *cmd, char *opts)
{
    extern spawn(PSJOB);
    char ExeName[64];
    SJOB s;
    int xstat;
    int IPipe = -1;
    int OPipe;
    
/*-------------------------------------------------------------.
| This is a (cheap) dummy to keep everything happy There is no |
| universal QDOS nul device, this is a dummy.		       |
`-------------------------------------------------------------*/
    OPipe = io_open ("pipe_16", 0);

    memset (&s, '\0', sizeof (SJOB));

/* We need the full path name, search pdir and ddir.  */

    s.FileName = FullName(stpblk(cmd), ExeName);

/*  Use dummy stdin (NUL) for child, so connected to our dummy above */

    s.InFile = "pipe_0";
    s.inflag = OPipe;

/*  Any command arguments (five minutes or the full 1/2 hour ?? */

    s.ComStr = *opts ? opts : NULL;

/*  Childs output (stdout) channel */

    s.OuFile = "pipe_4096";

/*  Also its stderr */
    s.serr = -1;

/*  Child is asynchronous. */

    s.Wait = 0;

/*  Child priority 16 */
    s.Prio = 16;

/*  I die, it dies too :-) */

    s.JobId = -1;


/*--------------------------------------------------------------.
|    If we can start the child job, we connect a channel to its |
|    (stdout) pipe.					        |
`--------------------------------------------------------------*/

    if ((xstat = spawn (&s)) == 0)
    {
        IPipe = io_open ("pipe_0", s.ouid);
    }

/*--------------------------------------------------------------.
|  We can track the child dying by getting an EOF on IPipe Note |
| these are QDOS Channel IDs,				        |
`--------------------------------------------------------------*/
    return IPipe;
}
